
using System;
using System.Collections;
using System.ComponentModel;
using Vector;
using Vector.Units;

using System.Collections.ObjectModel;
using System.ComponentModel.Design.Serialization;
//using Borland.Vcl.AppEvnts;
using System.Runtime.InteropServices;
// === File Prolog ============================================================

// === End File Prolog ========================================================

namespace Flock
{
    public class TCustomFlock : Component
    {
        public float MinTimeToMaxSpeed
        {
            get
            {
                return FMinTimeToMaxSpeed;
            }
        }
        public TAutoCalcProperty[] AutoCalcProperties
        {
            get
            {
                return FAutoCalcProperties;
            }
            set
            {
                FAutoCalcProperties = value;
            }
        }
        public TFlockCollection Boids
        {
            get
            {
                return FBoids;
            }
            set
            {
                SetBoids(value);
            }
        }
        public float DesiredSpeed
        {
            get
            {
                return FDesiredSpeed;
            }
            set
            {
                FDesiredSpeed = value;
            }
        }
        public TFlockingBehavior[] Behaviors
        {
            get
            {
                return FBehaviors;
            }
            set
            {
                FBehaviors = value;
            }
        }
        public float MaxChange
        {
            get
            {
                return FMaxChange;
            }
            set
            {
                SetMaxChange(value);
            }
        }
        public float MaxSpeed
        {
            get
            {
                return FMaxSpeed;
            }
            set
            {
                SetMaxSpeed(value);
            }
        }
        public float MaxUrgency
        {
            get
            {
                return FMaxUrgency;
            }
            set
            {
                SetMaxUrgency(value);
            }
        }
        public float MinUrgency
        {
            get
            {
                return FMinUrgency;
            }
            set
            {
                SetMinUrgency(value);
            }
        }
        public TVector Position
        {
            get
            {
                return FPosition;
            }
            set
            {
                SetPosition(value);
            }
        }
        public TVector Velocity
        {
            get
            {
                return FVelocity;
            }
            set
            {
                SetVelocity(value);
            }
        }
        public TBoidEvent OnBoidAdded
        {
            get
            {
                return FOnBoidAdded;
            }
            set
            {
                FOnBoidAdded = value;
            }
        }
        public TBoidEvent OnBoidDelete
        {
            get
            {
                return FOnBoidDelete;
            }
            set
            {
                FOnBoidDelete = value;
            }
        }
        public TBoidEvent OnBoidExecuted
        {
            get
            {
                return FOnBoidExecuted;
            }
            set
            {
                FOnBoidExecuted = value;
            }
        }
        public TBoidEvent OnBoidExecuting
        {
            get
            {
                return FOnBoidExecuting;
            }
            set
            {
                FOnBoidExecuting = value;
            }
        }
        public TBoidApplyChangeEvent OnApplyAvoidance
        {
            get
            {
                return FOnApplyAvoidance;
            }
            set
            {
                FOnApplyAvoidance = value;
            }
        }
        public TBoidApplyChangeEvent OnApplyAlignment
        {
            get
            {
                return FOnApplyAlignment;
            }
            set
            {
                FOnApplyAlignment = value;
            }
        }
        public TBoidApplyChangeEvent OnApplyCohesion
        {
            get
            {
                return FOnApplyCohesion;
            }
            set
            {
                FOnApplyCohesion = value;
            }
        }
        public TBoidApplyChangeEvent OnApplySeparation
        {
            get
            {
                return FOnApplySeparation;
            }
            set
            {
                FOnApplySeparation = value;
            }
        }
        public TNotifyEvent OnClear
        {
            get
            {
                return FOnClear;
            }
            set
            {
                FOnClear = value;
            }
        }
        public TBoidEvent OnBoidChange
        {
            get
            {
                return FOnBoidChange;
            }
            set
            {
                FOnBoidChange = value;
            }
        }
        public TNotifyEvent OnChange
        {
            get
            {
                return FOnChange;
            }
            set
            {
                FOnChange = value;
            }
        }
        public TNotifyEvent OnExecuting
        {
            get
            {
                return FOnExecuting;
            }
            set
            {
                FOnExecuting = value;
            }
        }
        public TNotifyEvent OnExecuted
        {
            get
            {
                return FOnExecuted;
            }
            set
            {
                FOnExecuted = value;
            }
        }
        public float AvoidanceDistance
        {
            get
            {
                return FAvoidanceDistance;
            }
            set
            {
                SetAvoidanceDistance(value);
            }
        }
        public float SeparationDistance
        {
            get
            {
                return FSeparationDistance;
            }
            set
            {
                SetSeparationDistance(value);
            }
        }
        public float StrengthAlignment
        {
            get
            {
                return FStrengthAlignment;
            }
            set
            {
                FStrengthAlignment = value;
            }
        }
        public float StrengthAvoidance
        {
            get
            {
                return FStrengthAvoidance;
            }
            set
            {
                FStrengthAvoidance = value;
            }
        }
        public float StrengthSeparation
        {
            get
            {
                return FStrengthSeparation;
            }
            set
            {
                FStrengthSeparation = value;
            }
        }
        public float StrengthCohesion
        {
            get
            {
                return FStrengthCohesion;
            }
            set
            {
                FStrengthCohesion = value;
            }
        }

        public float NeigboursRankSeparation
        {
            get
            {
                return FNeigboursRankSeparation;
            }
            set
            {
                FNeigboursRankSeparation = value;
            }
        }

        public TFlockWorld World
        {
            get
            {
                return FWorld;
            }
            set
            {
                SetWorld(value);
            }
        }


        //SR Add
        public Object Tag
        {
            get
            {
                return FTag;
            }
            set
            {
                FTag = value;
            }
        }
        // Private declarations
        private Object FTag = null;//SR Add
        private TFlockCollection FBoids = null;
        private TNotifyEvent FOnChange = null;
        private TBoidEvent FOnBoidChange = null;
        private float FSeparationDistance = 0;
        private float FMinUrgency = 0;
        private float FMaxUrgency = 0;
        private TVector FPosition = null;
        private float FMaxSpeed = 0;
        private float FDesiredSpeed = 0;
        private float FMaxChange = 0;
        private TFlockWorld FWorld = null;
        private TFlockingBehavior[] FBehaviors = { TFlockingBehavior.fbSeparation };
        private float FStrengthAlignment = 0;
        private float FStrengthSeparation = 0;
        private float FNeigboursRankSeparation = 0;

        private float FStrengthCohesion = 0;
        private TVector FVelocity = null;
        private float FAvoidanceDistance = 0;
        private float FStrengthAvoidance = 0;
        private TAutoCalcProperty[] FAutoCalcProperties = new TAutoCalcProperty[2] { TAutoCalcProperty.acpPosition, TAutoCalcProperty.acpVelocity };
        private int FUpdateCount = 0;
        private TNotifyEvent FOnExecuted = null;
        private TNotifyEvent FOnExecuting = null;
        private TBoidEvent FOnBoidDelete = null;
        private TBoidEvent FOnBoidAdded = null;
        private TNotifyEvent FOnClear = null;
        private TBoidApplyChangeEvent FOnApplyAvoidance = null;
        private TBoidApplyChangeEvent FOnApplyCohesion = null;
        private TBoidApplyChangeEvent FOnApplySeparation = null;
        private TBoidApplyChangeEvent FOnApplyAlignment = null;
        private TBoidEvent FOnBoidExecuted = null;
        private TBoidEvent FOnBoidExecuting = null;
        private float FMinTimeToMaxSpeed = 0;
        public bool localInformation = false;
        public int responseDelay = 0;
        // TCustomFlock
        public void Assign(Object Source)
        {
            FOnChange = ((TFlock)Source).FOnChange;
            FOnBoidChange = ((TFlock)Source).FOnBoidChange;

            FOnExecuted = ((TFlock)Source).FOnExecuted;
            FOnExecuting = ((TFlock)Source).FOnExecuting;
            FOnBoidDelete = ((TFlock)Source).FOnBoidDelete;
            FOnBoidAdded = ((TFlock)Source).FOnBoidAdded;
            FOnClear = ((TFlock)Source).FOnClear;
            FOnApplyAvoidance = ((TFlock)Source).FOnApplyAvoidance;
            FOnApplyCohesion = ((TFlock)Source).FOnApplyCohesion;
            FOnApplySeparation = ((TFlock)Source).FOnApplySeparation;
            FOnApplyAlignment = ((TFlock)Source).FOnApplyAlignment;
            FOnBoidExecuted = ((TFlock)Source).FOnBoidExecuted;
            FOnBoidExecuting = ((TFlock)Source).FOnBoidExecuting;


        }

        public void BeginUpdate()
        {
            FUpdateCount++;
        }

        public void BoidChange(TBoid Boid)
        {
            if (FOnBoidChange != null)
                FOnBoidChange(this, Boid);

        }

        public void Change()
        {
            if (FUpdateCount > 0)
                return;

            if ((FOnChange != null))
            {
                FOnChange(this);
            }

        }

        //Constructor  Create( AOwner)
        public TCustomFlock(Component AOwner)
        {



            World = ((TFlockWorld)AOwner);
            FAutoCalcProperties = new TAutoCalcProperty[2] { TAutoCalcProperty.acpPosition, TAutoCalcProperty.acpVelocity };
            FMinUrgency = 0.05f;
            FMaxUrgency = 0.1f;
            FMaxSpeed = 1;
            FDesiredSpeed = MaxSpeed / 2;
            FMaxChange = MaxSpeed * MaxUrgency;
            FMinTimeToMaxSpeed = MaxSpeed / MaxChange;
            FAvoidanceDistance = 6;
            FSeparationDistance = 3;
            FPosition = new TFlockVector(this);
            FVelocity = new TFlockVector(this);
            FBehaviors = new TFlockingBehavior[4] { TFlockingBehavior.fbSeparation, TFlockingBehavior.fbAlignment, TFlockingBehavior.fbCohesion, TFlockingBehavior.fbAvoidance };
            FStrengthAlignment = 1;
            FStrengthAvoidance = 1;
            FStrengthSeparation = 1;
            FNeigboursRankSeparation = 1;
            FStrengthCohesion = 1;
            FBoids = CreateFlock();


        }
        public TFlockCollection CreateFlock()
        {
            TFlockCollection result = new TFlockCollection(this);
            return result;
        }

        //@ Destructor  Destroy()
        ~TCustomFlock()
        {
        }
        public void EndUpdate()
        {
            FUpdateCount -= 1;
            Change();
        }

        public void Notification(Component AComponent, TOperation Operation)
        {

            //inherited  Notification( AComponent, Operation );
            if ((Operation == TOperation.opRemove) && (AComponent == World))
                World = null;
        }

        public void SetBoids(TFlockCollection Value)
        {
            Boids = Value;
        }

        public void SetMaxUrgency(float Value)
        {

            if (Value != MaxUrgency)
            {
                MaxUrgency = Value;
                if (MaxUrgency < MinUrgency)
                    FMinUrgency = Value;
            }
        }

        public void SetMinUrgency(float Value)
        {
            if (Value != FMinUrgency)
            {

                FMinUrgency = Value;
                if (MaxUrgency < MinUrgency)
                    FMaxUrgency = Value;
            }
        }

        public void SetPosition(TVector Value)
        {
            Position.Assign(Value);
        }

        public void SetVelocity(TVector Value)
        {
            FVelocity.Assign(Value);
        }

        public void SetWorld(TFlockWorld Value)
        {
            if (World != Value)
            {

                if (World != null)
                {
                    //World.RemoveFreeNotification(this);
                    World.Flocks.Remove(this);
                }


                FWorld = Value;
                if (Value != null)
                {
                    //Value.FreeNotification(Self);
                    Value.Flocks.Add(this);
                }
            }

        }

        public void Execute()
        {


            int i;

            BeginUpdate();
            Executing();
            if (/*( AutoCalcProperties) !=null) &&*/ (Boids.Count > 0))
            {

                // Find new position of flock by averaging all the flockmates positions
                if (this.AutoCalcProperties[0] == TAutoCalcProperty.acpPosition)
                    Position = Boids[0].Position;
                if (this.AutoCalcProperties[1] == TAutoCalcProperty.acpVelocity)

                    Velocity = Boids[0].Velocity;

                for (i = 1; i < Boids.Count; i++)
                {//do

                    if (this.AutoCalcProperties[0] == TAutoCalcProperty.acpPosition)
                        Position.Add(Boids[i].Position);
                    if (this.AutoCalcProperties[1] == TAutoCalcProperty.acpVelocity)
                        Velocity.Add(Boids[i].Velocity);

                }

                if (this.AutoCalcProperties[0] == TAutoCalcProperty.acpPosition)
                    Position.Divide(Boids.Count);
                if (this.AutoCalcProperties[1] == TAutoCalcProperty.acpVelocity)
                    Velocity.Divide(Boids.Count);
                if (this.AutoCalcProperties[0] == TAutoCalcProperty.acpVelocity && this.AutoCalcProperties[1] == TAutoCalcProperty.acpVelocity)
                    Velocity.Clear();
            }
            // Update every member of the flock for the time period
            for (i = 0; i < Boids.Count/* - 1*/; i++)
            {
                Boids[i].Execute();

            }
            Executed();

            EndUpdate();


        }

        public void Executed()
        {
            if (OnExecuted != null)
                OnExecuted(this);
        }

        public void Executing()
        {
            if (OnExecuting != null)
                OnExecuting(this);
        }

        public void BoidAdded(TBoid Boid)
        {
            Boids[Boids.Count + 1] = Boid;
            //Boid.Assign(this);
            //this.OnBoidAdded(this,Boid);
            if (FOnBoidAdded != null)
                FOnBoidAdded(this, Boid);
        }

        public void BoidClear()
        {
            if (FOnClear != null)
                FOnClear(this);
        }

        public void BoidDelete(TBoid Boid)
        {
            if (FOnBoidDelete != null)
                FOnBoidDelete(this, Boid);
        }

        public void BoidApplyRule(TBoid Boid, TFlockingBehavior Rule, TVector Accumulator, TVector Change)
        {

            switch (Rule)
            {
                case TFlockingBehavior.fbSeparation:
                    if (FOnApplySeparation != null)
                        FOnApplySeparation(this, Boid, Accumulator, Change);
                    break;
                case TFlockingBehavior.fbAlignment:
                    if (FOnApplyAlignment != null)
                        FOnApplyAlignment(this, Boid, Accumulator, Change);
                    break;
                case TFlockingBehavior.fbCohesion:
                    if (FOnApplyCohesion != null)
                        FOnApplyCohesion(this, Boid, Accumulator, Change);
                    break;
                case TFlockingBehavior.fbAvoidance:
                    if (FOnApplyAvoidance != null)
                        FOnApplyAvoidance(this, Boid, Accumulator, Change);
                    break;
            }

        }

        public void BoidExecuted(TBoid Boid)
        {

            if (FOnBoidExecuted != null)
                FOnBoidExecuted(this, Boid);
        }

        public void BoidExecuting(TBoid Boid)
        {
            if (FOnBoidExecuting != null)
                FOnBoidExecuting(this, Boid);
        }

        public void SetMaxChange(float Value)
        {
            if (Value != MaxChange)
            {

                if (Value < 0.00001)
                    FMaxChange = 0.00001f;
                else
                    FMaxChange = Value;
                FMinTimeToMaxSpeed = MaxSpeed / MaxChange;
            }

        }

        public void SetMaxSpeed(float Value)
        {

            if (Value != MaxSpeed)
            {

                if (Value < 0)
                    FMaxSpeed = 0;
                else
                    FMaxSpeed = Value;
                FMinTimeToMaxSpeed = MaxSpeed / MaxChange;
            }
        }

        public void VectorChange(TVector Sender)
        {
        }

        public void SetAvoidanceDistance(float Value)
        {
            if (Value < 0)
                FAvoidanceDistance = 0;
            else
                FAvoidanceDistance = Value;

        }

        public void SetSeparationDistance(float Value)
        {
            if (Value < 0)
                FSeparationDistance = 0;
            else
                FSeparationDistance = Value;
        }

    } // end TCustomFlock

    public class TBoid : System.Collections.CollectionBase/* TCollectionItem*/
    {
        protected TVector OldPosition
        {
            get
            {
                return FOldPosition;
            }
        }
        protected TVector OldVelocity
        {
            get
            {
                return FOldVelocity;
            }
        }
        public TCustomFlock Flock
        {
            get
            {
                return FFlock;
            }
            set
            {
                FFlock = value;
            }
        }
        public TBoid NearestEnemy
        {
            get
            {
                return FNearestEnemy;
            }
        }
        public float NearestEnemyDist
        {
            get
            {
                return FNearestEnemyDist;
            }
        }
        public TBoid NearestFlockMate
        {
            get
            {
                if (Flock.NeigboursRankSeparation == 1)
                    return FNearestFlockMate;
                else
                    return FNearestVirtualFlockMate;
            }
        }

        public TBoid NearestVirtualFlockMate
        {
            get
            {
                return FNearestVirtualFlockMate;
            }
        }
        //public TBoid FlockMates
        //{
        //    get
        //    {
        //        return FFlockMates;
        //    }
        //}


        public float NearestFlockMateDist
        {
            get
            {
                if (Flock != null)
                {
                    return FNearestFlockMateDist;
                }

                else
                    return FNearestVirtualFlockMate.FNearestFlockMateDist;
            }
        }
        // Published declarations
        public TVector Orientation
        {
            get
            {
                return FOrientation;
            }
            set
            {
                SetOrientation(value);
            }
        }
        public TVector Position
        {
            get
            {
                return FPosition;
            }
            set
            {
                SetPosition(value);
            }
        }
        public float Speed
        {
            get
            {
                return FSpeed;
            }
            set
            {
                SetSpeed(value);
            }
        }
        public int/*TRSTag*/ Tag
        {
            get
            {
                return FTag;
            }
            set
            {
                FTag = value;
            }
        }
        public TVector Velocity
        {
            get
            {
                return FVelocity;
            }
            set
            {
                SetVelocity(value);
            }
        }
        // Private declarations
        private TVector FOldPosition = new TVector();
        private TVector FPosition = new TVector();
        private TVector FOrientation = new TVector();
        private TVector FVelocity = new TVector();
        private TVector FOldVelocity = new TVector();
        private TCustomFlock FFlock = null;
        private float FNearestFlockMateDist = 0;
        private TBoid FNearestFlockMate = null;
        private TBoid FNearestVirtualFlockMate = null;

        public ArrayList FFlockMates = new ArrayList();

        public ArrayList velocityDelayedBuf = new ArrayList();
        public int iterCnt = 1;

        private float FSpeed = 0;
        private float FNearestEnemyDist = 0;
        private TBoid FNearestEnemy = null;
        private int/*TRSTag*/ FTag = 0/*null*/;
        // Public declarations
        // TBoid
        public /*override*/ void Assign(Object Source)
        {
            if (Source is TBoid)
            {
                FTag = ((Source) as TBoid).Tag;
                FOldPosition.Assign(((Source) as TBoid).FOldPosition);
                FPosition.Assign(((Source) as TBoid).Position);
                FOrientation.Assign(((Source) as TBoid).Orientation);
                FVelocity.Assign(((Source) as TBoid).Velocity);
                FOldVelocity.Assign(((Source) as TBoid).FOldVelocity);
                FSpeed = ((Source) as TBoid).FSpeed;

                //Changed(false);

                return;
            }
            //base.Assign(Source);
        }

        public virtual void ComputeOrientation()
        {
            float roll;
            float pitch;
            float yaw;
            TVector Temp;
            TVector LateralDir;
            float LateralMag;
            double SqrtVel;
            // Determine the direction of the lateral acceleration.
            Temp = new TVector(Velocity);
            LateralDir = new TVector(Velocity);
            try
            {
                Temp.Subtract(OldVelocity);
                LateralDir.CrossProduct(Temp);
                LateralDir.CrossProduct(Velocity);
                LateralDir.Normalize();
                // Set the lateral acceleration's magnitude.
                // The magnitude is the vector
                // projection of the appliedAcceleration vector
                // onto the direction of the lateral acceleration.
                Temp.Assign(Velocity);
                Temp.Subtract(OldVelocity);
                LateralMag = Temp.DotProduct(LateralDir);
                // compute roll
                if (LateralMag == 0)
                {
                    roll = 0;
                }
                else
                {

                    roll = -(float)(Math.Atan2(Convert.ToDouble(Flock.World.Gravity), LateralMag) + Units.Flock.Half_PI);
                }
                // compute pitch
                SqrtVel = Math.Sqrt((Velocity.Z * Velocity.Z) + (Velocity.X * Velocity.X));
                if (SqrtVel == 0)
                {
                    pitch = -(float)Math.Atan(0.0);
                }
                else
                {
                    pitch = -(float)Math.Atan(Velocity.Y / SqrtVel);
                }
                // compute yaw
                yaw = (float)Math.Atan2(Velocity.X, Velocity.Z);
                Orientation.SetXYZ(pitch, yaw, roll);
            }
            finally
            {
                //@ Unsupported property or method(C): 'Free'
                //Temp.Free;
                //@ Unsupported property or method(C): 'Free'
                //LateralDir.Free;
            }
        }

        //Constructor  Create( Collection)
        public TBoid(ArrayList Collection)
            : base() //: System.ComponentModel.ComponentCollection(Collection) base(Collection)
        {
            //@ Unsupported property or method(C): 'Flock'
            this.Flock = ((TFlockCollection)Collection).Flock;
            FOrientation = new TVector();
            FPosition = new TVector();
            FVelocity = new TVector();
            FOldPosition = new TVector();
            FOldVelocity = new TVector();
            FNearestVirtualFlockMate = new TBoid();
        }

        public TBoid()
        //: System.ComponentModel.ComponentCollection(Collection) base(Collection)
        {
            //@ Unsupported property or method(C): 'Flock'
            this.Flock = null;
            FOrientation = new TVector();
            FPosition = new TVector();
            FVelocity = new TVector();
            FOldPosition = new TVector();
            FOldVelocity = new TVector();
        }
        //@ Destructor  Destroy()
        ~TBoid()
        {
            //@ Unsupported property or method(C): 'Free'
            //FOrientation.Free;
            //@ Unsupported property or method(C): 'Free'
            //FPosition.Free;
            //@ Unsupported property or method(C): 'Free'
            //FVelocity.Free;
            //@ Unsupported property or method(C): 'Free'
            //FOldPosition.Free;
            //@ Unsupported property or method(C): 'Free'
            //FOldVelocity.Free;
            //base.Destroy();
        }
        public virtual void ApplyCruising(TVector Accumulator)
        {
            // Create a vector that the flock mate would follow if no other units
            // were in a flock
            TVector Change;
            float Diff;
            float Urgency;
            float Jitter;
            // Copy the heading of nearest flock mate
            Change = new TVector(Velocity);
            try
            {

                Diff = (Speed - Flock.DesiredSpeed) / Flock.MaxSpeed;
                Urgency = Math.Abs(Diff);

                if (Urgency < Flock.MinUrgency)
                {

                    Urgency = Flock.MinUrgency;
                }

                else if (Urgency > Flock.MaxUrgency)
                {

                    Urgency = Flock.MaxUrgency;
                }
                // Add in some randomness in X, Y, or Z
                Jitter = (float)(new System.Random()).NextDouble();
                if (Jitter < 0.45)
                {

                    Change.X = Change.X + (Flock.MinUrgency * Units.Flock.Sign(Diff));
                }
                else if (Jitter < 0.9)
                {

                    Change.Z = Change.X + (Flock.MinUrgency * Units.Flock.Sign(Diff));
                }
                else
                {

                    Change.Y = Change.X + (Flock.MinUrgency * Units.Flock.Sign(Diff));
                }
                // normalize change to look more natural
                Change.SetMagnitudeOfVector(Urgency * (-Units.Flock.Sign(Diff)));
                // Add Change to Accumulator
                Accumulator.Add(Change);
            }
            finally
            {

                //Change.Free;
            }
        }

        public virtual void ApplyAvoidance(TVector Accumulator)
        {
            TVector Change;

            if (Flock.StrengthAvoidance == 0)
            {
                return;
            }
            // Flocking Rule: Avoidance

            if (NearestEnemyDist >= Flock.AvoidanceDistance)
            {
                Change = new TVector();
            }
            else
            {
                // Try to avoid enemy flocks
                Change = new TVector(Position);
            }
            try
            {

                if (NearestEnemyDist < Flock.AvoidanceDistance)
                {
                    // compute vector towards our nearest enemy
                    Change.Subtract(NearestEnemy.Position);

                    Change.SetMagnitudeOfVector(Flock.MaxUrgency * Flock.StrengthAvoidance);
                }
                // Add Change to Accumulator
                if (Flock != null)
                {

                    Flock.BoidApplyRule(this, TFlockingBehavior.fbAvoidance, Accumulator, Change);
                }
                Accumulator.Add(Change);
            }
            finally
            {

                //Change.Free;
            }
        }

        public void ApplySeparation(TVector Accumulator)
        {

            float Ratio;
            TVector Change;

            if (this.Flock.StrengthSeparation == 0)
                return;
            // Flocking Rule: Separation
            // Try to avoid boid colliding with its flockmates
            if (NearestFlockMate == null)
                return;//TODO Message
            Change = new TVector(NearestFlockMate.Position);
            // compute vector towards our nearest flock mate
            Change.Subtract(Position);
            // Compute ratio of nearest flock mate to separation distance
            // and ensure it is in range of MinUrgency..MaxUrgency
            Ratio = NearestFlockMateDist / Flock.SeparationDistance;
            if (Ratio < Flock.MinUrgency)
                Ratio = Flock.MinUrgency;
            else if (Ratio > Flock.MaxUrgency)
                Ratio = Flock.MaxUrgency;

            Ratio = Ratio * Flock.StrengthSeparation;
            // Are we too close to nearest flockmate?  Then Move Away
            if (NearestFlockMateDist < Flock.SeparationDistance)
                Change.SetMagnitudeOfVector(-Ratio);
            // Are we too far from nearest flockmate?  Then Move Closer
            else if (NearestFlockMateDist > Flock.SeparationDistance)
                Change.SetMagnitudeOfVector(Ratio);
            else // just right
                Change.Clear();
            // Add Change to Accumulator
            if (Flock != null)
                Flock.BoidApplyRule(this, TFlockingBehavior.fbSeparation, Accumulator, Change);
            Accumulator.Add(Change);
            //Change.Free;

        }

        public void ApplyAlignment(TVector Accumulator)
        {

            TVector Change;

            if (Flock.StrengthAlignment == 0)
                return;
            // Flocking Rule: Alignment
            // Try to align boid's heading with its flockmates
            // Copy the heading of the flock
            if (Flock.localInformation == false)
                Change = new TVector(Flock.Velocity);
            else
                Change = new TVector(this.NearestFlockMate.Velocity);


            // normalize change to look more natural
            Change.SetMagnitudeOfVector(Flock.MinUrgency * Flock.StrengthAlignment);
            // Add Change to Accumulator
            if (Flock != null)
                Flock.BoidApplyRule(this, TFlockingBehavior.fbAlignment, Accumulator, Change);
            Accumulator.Add(Change);

            //Change.Free;

        }

        public void SeeFlockmates()
        {

            int i;
            float Dist;

            // Unlike S. Woodcock's implementation, we are just going to
            // concern ourself with the nearest flock mate.  All flock mates
            // are considered visible
            FNearestFlockMate = null;
            FNearestFlockMateDist = Int32.MaxValue;

            if (Flock.NeigboursRankSeparation == 1)
            {
                for (i = 0; i <= Flock.Boids.Count - 1; i++)
                {
                    if (Flock.Boids[i] != this)
                    {
                        Dist = (float)Position.DistanceSqrTo(Flock.Boids[i].Position);
                        if (Dist < NearestFlockMateDist)
                        {
                            FNearestFlockMateDist = Dist;
                            FNearestFlockMate = Flock.Boids[i];

                        }

                    }
                }

                FNearestFlockMateDist = (float)Math.Sqrt(NearestFlockMateDist);
            }



            //and limit the visibility only to neigbours...


            if (Flock.NeigboursRankSeparation > 1)
            {

                for (i = 0; i <= Flock.Boids.Count - 1; i++)
                {
                    if (Flock.Boids[i] != this)
                    {
                        Dist = (float)Position.DistanceSqrTo(Flock.Boids[i].Position);

                        Units.FlockmatesRank temp = new Units.FlockmatesRank();
                        temp.Distance = (float)Math.Sqrt(Dist);
                        temp.boid = Flock.Boids[i];
                        this.FFlockMates.Add(temp);
                    }
                }

                // Sort ArrayList.
                FFlockMates.Sort();

                FNearestVirtualFlockMate.Position.Clear();
                FNearestVirtualFlockMate.Velocity.Clear();

                for (i = 0; i < Flock.NeigboursRankSeparation; i++)
                {
                    if ((Units.FlockmatesRank)(FFlockMates[i]) != null)
                    {
                        FNearestVirtualFlockMate.Velocity.Add(((Units.FlockmatesRank)(FFlockMates[i])).boid.Velocity);
                        FNearestVirtualFlockMate.Position.Add(((Units.FlockmatesRank)(FFlockMates[i])).boid.Position);
                    }
                }
                FNearestVirtualFlockMate.Position.Divide(Flock.NeigboursRankSeparation);
                FNearestVirtualFlockMate.Velocity.Divide(Flock.NeigboursRankSeparation);

                FNearestFlockMateDist = Position.DistanceTo(FNearestVirtualFlockMate.Position);

                FFlockMates.Clear();
            }

        }

        public void SeeEnemyFlocks()
        {

            int i, j;
            float Dist;
            TCustomFlock AFlock;

            // Unlike S. Woodcock's implementation, we are just going to
            // concern ourself with the nearest enemy flock member.  All flock members
            // are considered visible
            FNearestEnemy = null;
            FNearestEnemyDist = Int32.MaxValue;
            for (j = 0; j <= Flock.World.FlockCount - 1; j++)
            {

                if (Flock.World.Flock(j) != Flock)
                {
                    AFlock = Flock.World.Flock(j);
                    for (i = 0; i <= AFlock.Boids.Count - 1; i++)
                    {
                        Dist = (float)Position.DistanceSqrTo(AFlock.Boids[i].Position);
                        if (Dist < FNearestEnemyDist)
                        {
                            FNearestEnemyDist = Dist;
                            FNearestEnemy = AFlock.Boids[i];
                        }
                    }
                }
            }
            FNearestEnemyDist = (float)Math.Sqrt(FNearestEnemyDist);
        }

        public void SetOrientation(TVector Value)
        {
            FOrientation.Assign(Value);
            //Changed(False);
        }

        public void SetPosition(TVector Value)
        {
            FPosition.Assign(Value);
            //Changed(False);
        }

        public void SetVelocity(TVector Value)
        {
            FVelocity.Assign(Value);
            //Changed(False);
        }

        public void ApplyCohesion(TVector Accumulator)
        {
            TVector Change;

            if (Flock.StrengthCohesion == 0)
                return;
            // Flocking Rule: Cohesion
            // Try to go toward where all the flockmates are (the flock's center point)
            // Copy the position of center of flock
            Change = new TVector(Flock.Position);

            // Average with our position
            Change.Subtract(Position);
            // normalize change to look more natural
            Change.SetMagnitudeOfVector(Flock.MinUrgency * Flock.StrengthCohesion);
            // Add Change to Accumulator
            if (Flock != null)
                Flock.BoidApplyRule(this, TFlockingBehavior.fbCohesion, Accumulator, Change);
            Accumulator.Add(Change);

            //Change.Free;


        }

        public void Execute()
        {

            TVector Accum;

            Executing();
            // Save Current position
            FOldPosition.Assign(Position);
            // Flocking Rules
            Accum = new TVector();

            // Update position based on velocity
            FPosition.Add(Velocity);
            // Flocking Rules
            ApplyFlockingRules(Accum);
            UpdateVelocity(Accum);
            Speed = Velocity.Length();
            if (Speed > Flock.MaxSpeed)
            {

                FSpeed = Flock.MaxSpeed;
                Velocity.SetMagnitudeOfVector(Speed);
            }
            //added by sr
            else /*if (Speed < Flock.MaxUrgency)*/
            {
                //FSpeed = 0.0f;
                Velocity.SetMagnitudeOfVector(Speed);
            }

            // Compute Orientation
            ComputeOrientation();
            WorldBound();

            //Accum.;

            Executed();

        }

        public void WorldBound()
        {

            if ((Flock == null) || (Flock.World == null))
                return;
            if (FPosition.X < Flock.World.Origin.X)
                FPosition.X = Flock.World.Dimension.X;
            else if (FPosition.X > Flock.World.Dimension.X)
                FPosition.X = Flock.World.Origin.X;

            if (FPosition.Y < Flock.World.Origin.Y)
                FPosition.Y = Flock.World.Dimension.Y;
            else if (FPosition.Y > Flock.World.Dimension.Y)
                FPosition.Y = Flock.World.Origin.Y;

            if (FPosition.Z < Flock.World.Origin.Z)
                FPosition.Z = Flock.World.Dimension.Z;
            else if (FPosition.Z > Flock.World.Dimension.Z)
                FPosition.Z = Flock.World.Origin.Z;
        }

        public void ApplyFlockingRules(TVector Accumulator)
        {

            // Look for flock mates
            SeeFlockmates();
            //          Implement Rule #1 (Separation)
            // Try to maintain our desired separation distance from our nearest flockmate
            if (TFlockingBehavior.fbSeparation == Flock.Behaviors[0])

                ApplySeparation(Accumulator);
            //          Implement Rule #2 (Alignment).
            // Try to move the same way our nearest flockmate does
            if (TFlockingBehavior.fbAlignment == Flock.Behaviors[1])
                ApplyAlignment(Accumulator);
            //          Implement Rule #3 (Cohesion).
            // Try to move towards the center of the flock
            if (TFlockingBehavior.fbCohesion == Flock.Behaviors[2])
                ApplyCohesion(Accumulator);
            //          Implement Rule #4 (Avoidance).
            // Try to move away from enemies
            if (TFlockingBehavior.fbAvoidance == Flock.Behaviors[3])
            {
                SeeEnemyFlocks();
                ApplyAvoidance(Accumulator);
            }

            // ApplyCruising
            // Add in where we would go without anyone else around
            //ApplyCruising( Accumulator );
        }

        public void SetSpeed(float Value)
        {
            if (Speed != Value)
            {
                FSpeed = Value;
                //Changed(False);

            }
        }

        public void Executed()
        {
            if (Flock != null)
                Flock.BoidExecuted(this);
        }

        public void Executing()
        {
            if (Flock != null)
                Flock.BoidExecuting(this);
        }

        public void UpdateVelocity(TVector Accumulator)
        {
            // Ok, now limit speeds
            if (Accumulator.Length() > this.Flock.MaxChange)
                Accumulator.SetMagnitudeOfVector(Flock.MaxChange);
            // Save old velocity
            FOldVelocity.Assign(Velocity);

            // Calculate new velocity and constrain it
            Velocity.Add(Accumulator);
            //Velocity.Y = Velocity.Y * Flock.MaxUrgency;

            //Add delay for the dynamics of each flockmate
            if (Flock.responseDelay > 0)
            {


                velocityDelayedBuf.Add(FOldVelocity);
                velocityDelayedBuf.Add(Velocity);

                if (iterCnt % Flock.responseDelay == 0)
                {
                    iterCnt = 0;

                    FVelocity = (TVector)velocityDelayedBuf[Flock.responseDelay];
                    velocityDelayedBuf.RemoveAt(Flock.responseDelay);

                    FOldVelocity = (TVector)velocityDelayedBuf[Flock.responseDelay - 1];
                    velocityDelayedBuf.RemoveAt(Flock.responseDelay - 1);
                }

                if (velocityDelayedBuf.Count / 2 > Flock.responseDelay)
                {
                    velocityDelayedBuf.RemoveAt(velocityDelayedBuf.Count - 1);
                    velocityDelayedBuf.RemoveAt(velocityDelayedBuf.Count - 1);
                }


                iterCnt++;

            }
        }

    } // end TBoid

    public class TFlockCollection : ArrayList
    {
        public/*protected*/ TCustomFlock Flock
        {
            get
            {
                return FFlock;
            }
            set
            {
                FFlock = value;
            }
        }
        public TBoid this[int Index]
        {
            get
            {
                return GetItem(Index);
            }
            set
            {
                SetItem(Index, value);
            }
        }
        // Private declarations
        private TCustomFlock FFlock = null;
        // TFlockCollection
        public TBoid Add()
        {
            TBoid result = new TBoid(this.Flock.Boids);
            this.Add(result);
            Flock.BoidAdded(result);
            return result;
        }

        //Constructor  Create( Flock)
        public TFlockCollection(TCustomFlock flock)
        {
            this.FFlock = flock;

            TBoid cl = new TBoid(this);

            this.Create(flock, cl);
        }
        public void Clear()
        {
        }

        //Constructor  Create( Flock,  BoidClass)
        public void Create(TCustomFlock flock, TBoid/*TBoidClass*/ boidClass)
        {
            //int tr = base.Add(boidClass);
            //boidClass = new TBoid(this);
            this.FFlock = flock;

        }


        public void Delete(int Index)
        {
            if (Flock != null)
            {
                this.Remove(this.GetItem(Index));
                Flock.BoidDelete(this.GetItem(Index));
            }
            /*inherited*/
            //Delete(Index);
        }

        public TBoid GetItem(int Index)
        {
            TBoid result = (TBoid)base[Index];
            return result;
        }

        public Object GetOwner()
        {
            Object result = null;
            return result;
        }

        public TBoid Insert(int Index)
        {
            TBoid result = null;
            return result;
        }

        public void SetItem(int Index, TBoid Value)
        {
        }

        public void Update(/*TCollectionItem Item*/)
        {
        }

    } // end TFlockCollection

    // TFlockCollection
    public class TFlockVector : TVector
    {
        public TCustomFlock Flock
        {
            get
            {
                return FFlock;
            }
        }
        // Private Declarations
        private TCustomFlock FFlock = null;
        // TFlockVector
        public void Change()
        {
            Flock.VectorChange(this);
        }

        //Constructor  Create( Flock)
        public TFlockVector(TCustomFlock Flock)
        {
            //inherited Create;
            FFlock = Flock;
        }
    } // end TFlockVector

    // TFlock
    public class TFlockWorld : Component
    {
        public ArrayList Flocks
        {
            get
            {
                return FFlocks;
            }
        }
        public TCustomFlock Flock(int Index)
        {
            /*get {*/
            return GetFlock(Index);
            /*}*/
        }
        public int FlockCount
        {
            get
            {
                return GetFlockCount();
            }
        }
        // Published declarations
        public TVector Dimension
        {
            get
            {
                return FDimension;
            }
            set
            {
                SetDimension(value);
            }
        }
        public float Gravity
        {
            get
            {
                return FGravity;
            }
            set
            {
                FGravity = value;
            }
        }
        public TVector Origin
        {
            get
            {
                return FOrigin;
            }
            set
            {
                SetOrigin(value);
            }
        }
        // Private declarations
        private float FGravity = 0;
        private TVector FOrigin = new TVector();// null;
        private TVector FDimension = new TVector();// null;
        private ArrayList FFlocks = new ArrayList();// null;
        // TFlockWorld
        //Constructor  Create( AOwner)
        public TFlockWorld(Component AOwner)
        {
            //inherited Create( AOwner );

            FOrigin = new TVector();//TVector.Create;   
            FDimension = new TVector(100f, 100f, 100f);
            FGravity = 9.806650f;
            FFlocks = new ArrayList();// TList.Create;

        }

        public TFlockWorld()
        {
            FOrigin = new TVector();//TVector.Create;   
            FDimension = new TVector(100f, 100f, 100f);
            FGravity = 9.806650f;
            FFlocks = new ArrayList();// TList.Create;


        }
        //@ Destructor  Destroy()
        ~TFlockWorld()
        {
        }
        public TCustomFlock GetFlock(int Index)
        {
            TCustomFlock result = (TCustomFlock)Flocks[Index];
            return result;
        }

        public int GetFlockCount()
        {
            int result = FFlocks.Count;
            return result;
        }

        public void Notification(Component AComponent, TOperation Operation)
        {
            /*inherited*/
            //Notification( AComponent, Operation );
            //if ((AComponent.GetType() == (TCustomFlock))
            //{

            //    if (Operation == TOperation.opRemove)
            //        Flocks.Remove(AComponent);
            //}
        }

        public void SetDimension(TVector Value)
        {
        }

        public void SetOrigin(TVector Value)
        {
        }

    } // end TFlockWorld

    // TCustomFlock
    public class TFlock : TCustomFlock
    {
        // Published Declarations
        // property DesiredSpeed  commented out since ApplyCruising is not being used
        //public Object AutoCalcProperties;
        //public Object Boids;
        //public TFlockingBehavior/*object*/[] Behaviors;
        //public Object MaxChange;
        //public Object MaxSpeed;
        //public Object MaxUrgency;
        ////public object MinUrgency;
        //public Object Position;
        //public Object Velocity;
        //public Object OnBoidAdded;
        //public Object OnBoidDelete;
        //public Object OnBoidExecuted;
        //public Object OnBoidExecuting;
        //public Object OnApplyAvoidance;
        //public Object OnApplyAlignment;
        //public Object OnApplyCohesion;
        //public Object OnApplySeparation;
        //public Object OnClear;
        //public Object OnExecuting;
        //public Object OnExecuted;
        //public Object OnBoidChange;
        //public Object OnChange;
        //public float AvoidanceDistance;
        //public float SeparationDistance;
        //public float StrengthAlignment;
        //public float StrengthAvoidance;
        //public float StrengthSeparation;
        //public float StrengthCohesion;
        //public Object World;
        public TFlock(Component AOwner) : base(AOwner) { }
        //{
        //}
    } // end TFlock

    public delegate void TApplyChangeEvent(Object Sender, TVector Accumulator, TVector Change);
    public enum TFlockingBehavior
    {
        none,
        fbSeparation,
        fbAlignment,
        fbCohesion,
        fbAvoidance
    } // end TFlockingBehavior

    public delegate void TBoidEvent(Object Sender, TBoid Boid);
    public delegate void TBoidApplyChangeEvent(Object Sender, TBoid Boid, TVector Accumulator, TVector Change);

    public delegate void TNotifyEvent(Object Sender);

    public enum TAutoCalcProperty
    {
        acpPosition,
        acpVelocity
    } // end TAutoCalcProperty

    public enum TOperation////SR Add
    {
        opInsert,
        opRemove
    } // end TOperation

}

namespace Flock.Units
{
    public class Flock
    {
        public const double Half_PI = 3.14159 / 2;
        // TFlockWorld
        public static int Sign(float Val)
        {
            int result;
            if (Val < 0)
            {
                result = -1;
            }
            else if (Val > 0)
            {
                result = 1;
            }
            else
            {
                result = 0;
            }
            return result;
        }

    } // end Flock

    public class FlockmatesRank : IComparable
    {
        // The temperature value
        protected double flockmatesDistF;

        public TBoid boid = null;

        public int CompareTo(object obj)
        {
            if (obj is FlockmatesRank)
            {
                FlockmatesRank otherDist = (FlockmatesRank)obj;
                return this.flockmatesDistF.CompareTo(otherDist.flockmatesDistF);
            }
            else
            {
                throw new ArgumentException("Object is not a FlockmatesRank");
            }
        }

        public double Distance
        {
            get
            {
                return this.flockmatesDistF;
            }
            set
            {
                this.flockmatesDistF = value;
            }
        }


    }



}

